--Textured Polygon Demo-Original by xXxMoNkEyMaNxXx
local sin, cos, atan2, sqrt, pi, floor = math.sin, math.cos, math.atan2, math.sqrt, math.pi, math.floor
local gr, tm = love.graphics, love.timer
--localize
local down	= love.mouse.isDown
local pos	= love.mouse.getPosition
local time	= love.timer.getTime
--vars
local dragging
local offset

local tex = require 'Perspective'

function love.load()
	image = gr.newImage( 'lenaC.jpg' )
	width,height = gr.getWidth(), gr.getHeight()
	gr.setBackgroundColor( 55, 55, 255, 255 )
	gr.setCaption( 'Quad Texturing Effect Test' )
	vertices={ {100,100}, {200,100}, {200,200}, {100,200} }

	fig = {
		sides	= 4,
		angle	= 0,
		size	= 400,
		center	= { x = width / 2, y = height / 2 }
		}

	rotate		= true
	end

function love.draw()

	tex.quad(image,vertices[1],vertices[2],vertices[3],vertices[4])
	tex.quad(image,po[1],po[2],po[3],po[4])

	gr.setColor(255,255,0,255)
	gr.print( 'fps: '..tm.getFPS( ), width-100, height-20 )
	if show_data then data( po ) end
	end

function love.keypressed( key )
	if key == "escape" then love.event.quit()			end
	if key == 'm' then fig.angle 	= fig.angle+pi/180	end
	if key == 'n' then fig.angle 	= fig.angle-pi/180	end
	if key == 'd' then show_data 	= not show_data		end
	if key == 'r' then rotate		= not rotate		end
	end

function love.update( dt )
	if rotate then
		fig.angle	= fig.angle + dt / 2		end
	po				= create_quad( fig )
	---------------- xXxMoNkEyMaNxXx's code -----------------
	local x, y		= pos()
	local b1d		= down('l')
	if dragging then
		vertices[dragging] = { x + offset[1], y + offset[2] }
		if not b1d then
			dragging = nil
		end
		elseif b1d then
			local vc
			local best = math.huge
			for i,v in next,vertices do
				local dis = math.sqrt((v[1]-x)^2+(v[2]-y)^2)
				if dis < best then
					vc, best = i, dis
				end
			end
			dragging,offset = vc, {vertices[vc][1]-x,vertices[vc][2]-y}
		end
	end
	-----------------------------------------------------------
---------------------------------------------------------------
function create_quad( obj )
	local angle_step	= 90
	local poly			= {}
	for side			= 1, 4 do
		poly[side]		= {}
		poly[side][1]	= obj.size*sin((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.x
		poly[side][2]	= obj.size*cos((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.y
		end
	return poly
	end
----------------------------------------------------------------
function data( poo )
	msg = '{'..poo[1][1]..', '..poo[1][2]..'},{'..poo[2][1]..', '..poo[2][2]..'},{'..poo[3][1]..', '..poo[3][2]..'},{'..poo[4][1]..', '..poo[4][2]..'}'
	gr.print(msg,10,height-20)
	end
----------------------------------------------------------------
